\documentclass[a4paper,american,cleveref, autoref,lighttt]{lipics-v2019}

\usepackage[autopunct]{csquotes}
\MakeOuterQuote{"}
\usepackage{microtype}

\usepackage{amsmath,amssymb,amsthm}
\usepackage[bbgreekl]{mathbbol}
\allowdisplaybreaks

\usepackage{float}
\floatstyle{boxed}
\newfloat{algfloat}{tb}{alg}

\usepackage{thmtools,thm-patch}
\theoremstyle{definition}
\declaretheorem[preheadhook={\begin{algfloat}},postfoothook={\end{algfloat}}]{algorithm}
\declaretheorem[title=API,sibling=algorithm,preheadhook={\begin{algfloat}},postfoothook={\end{algfloat}}]{api}

\usepackage{listings}
\usepackage{lstautogobble}
\lstset{
  backgroundcolor=\color{white},
  aboveskip=2pt,
  belowskip=-10pt,
  columns=fullflexible,
  autogobble=true,
  numbers=left,
  numberstyle=\tiny\rmfamily\scshape\color{darkgray},
  numbersep=10pt,
  morecomment=[l]{//},
  commentstyle=\small\rmfamily\itshape,
  texcl=true,
  mathescape=true,
  literate=
    {...}{{$\ldots$}}2
}

\usepackage{tikz}
\usetikzlibrary{arrows.meta}
\usetikzlibrary{automata}
\usetikzlibrary{decorations.pathmorphing}
% Silence tikz error message when run inside listings math mode
\makeatletter
\global\let\tikz@ensure@dollar@catcode=\relax
\makeatother

\usepackage{tabto}



%\graphicspath{{./graphics/}}%helpful if your graphic files are in another directory

\author{Grzegorz Herman}{Theoretical Computer Science, Jagiellonian University, Kraków, Poland}{gherman@tcs.uj.edu.pl}{https://orcid.org/0000-0001-6855-8316}{}
\authorrunning{G. Herman}
\Copyright{Grzegorz Herman}

\title{Relational parsing: a clean, fast parsing strategy for all context-free languages}
%\titlerunning{Dummy short title}%optional, please use if title is longer than one line

\ccsdesc[500]{Theory of computation~Grammars and context-free languages}
\ccsdesc[500]{Software and its engineering~Syntax}

\keywords{context-free languages, generalized parsing, memoization, GLL}% mandatory: Please provide 1-5 keywords

\relatedversion{A full version of the paper is available at \url{https://arxiv.org/abs/1902.06591}}

%\acknowledgements{I want to thank \dots}%optional

%\nolinenumbers %uncomment to disable line numbering

%\hideLIPIcs  %uncomment to remove references to LIPIcs series (logo, DOI, ...), e.g. when preparing a pre-final version to be uploaded to arXiv or another public repository

%Editor-only macros:: begin (do not touch as author)%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\EventEditors{John Q. Open and Joan R. Access}
\EventNoEds{2}
\EventLongTitle{42nd Conference on Very Important Topics (CVIT 2016)}
\EventShortTitle{CVIT 2016}
\EventAcronym{CVIT}
\EventYear{2016}
\EventDate{December 24--27, 2016}
\EventLocation{Little Whinging, United Kingdom}
\EventLogo{}
\SeriesVolume{42}
\ArticleNo{23}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{document}
\TabPositions{.4\columnwidth,.5\columnwidth}

\newcommand{\bld}[1]{{\boldmath\textbf{#1}\unboldmath}}
\newcommand{\sstart}{s_{\textup{start}}}
\newcommand{\sstop}{s_{\textup{stop}}}
\newcommand{\con}{{\cdot}}
\newcommand{\cons}{{\cdots}}
\newcommand{\deq}{\triangleq}
\newcommand{\assign}{\mathrel{\mathop:}=}
\newcommand{\shift}[1]{\textup{\texttt{shift}}\langle#1\rangle}
\newcommand{\call}[1]{\textup{\texttt{call}}\langle#1\rangle}
\newcommand{\reduce}[1]{\textup{\texttt{reduce}}\langle#1\rangle}
\newcommand{\move}[1][~]{%
  \mathrel{%
    \begin{tikzpicture}[baseline={(base)}]
    \node[inner sep=.5ex,align=center] (tmp) {$\scriptstyle #1$};
    \node (base) at ([yshift=-.6ex]tmp.south) {};
    \draw[-{To[width=.8ex]}] decorate [decoration={coil,amplitude=.1ex,segment length=.5ex,aspect=0,post length=.4ex}] {(tmp.south west) -- (tmp.south east)};
    \end{tikzpicture}
    }
  }
\newcommand{\Eps}{D_\epsilon^*}
\newcommand{\C}[1]{\mathcal{C}(#1)}
\renewcommand{\S}[2][]{{\mathcal{S}_{#1}(#2)}}
\newcommand{\N}[1]{\overline{#1}}
\renewcommand{\P}[2]{\Phi_{#1 \rightsquigarrow #2}}
\newcommand{\deriv}[2][]{^{\textup{#1}(#2)}}
\newcommand{\efree}[1]{\underline{#1}}
\newcommand{\red}{_{\scriptscriptstyle-}}
\newcommand{\nred}{_{\scriptscriptstyle+}}
\newcommand{\out}[1][out]{_{\textup{#1}}}
\newcommand{\type}[1]{\mathbb{#1}}



\maketitle

\begin{abstract}
We present a novel parsing algorithm for all context-free languages,
based on computing the relation between configurations and reaching transitions in a recursive transition network.
Parsing complexity w.r.t. input length matches the state of the art:
it is worst-case cubic, quadratic for unambiguous grammars, and linear for LR-regular ones.
What distinguishes our algorithm is its clean mathematical formulation:
parsing is expressed as a composition of simple operations on languages and relations,
and can therefore be implemented using only immutable data structures.
With a proper choice of these structures,
a vast majority of operations performed during parsing typical programming languages can be memoized,
which allows our proof-of-concept implementation to outperform common generalized parsing algorithms,
in some cases by orders of magnitude.
\end{abstract}



\section{Introduction}

Parsing is a well-studied and yet still active topic in computer science.
Multiple highly efficient deterministic parsers can handle large families of unambiguous context-free grammars, and oftentimes more.
However, grammars of many programming languages do not naturally fit within the limitations required by these parsers, and need tedious manual adaptation
(e.g., replacing left recursion with right recursion).
Worse, such adaptation needs to be "undone" on parse trees, in order to make them reflect the desired structure of the language.
Further, in many cases the "natural" grammar of a language allows some ambiguity, which is easier resolved at a later compilation step.
With the growing need for rapid development of new languages,
generalized parsers---able to handle all, even ambiguous, context-free grammars---are gaining wider adoption.

Most generalized parsing techniques are based on clever parallel simulation of nondeterministic choices of a pushdown automaton.
Some of these algorithms offer good complexity guarantees: worst-case cubic, quadratic on unambiguous grammars, and in some cases linear on "nice" language fragments.
Nondeterminism is handled by means of (some variant of) a data structure called GSS (graph-structured stack).
This makes the constant factors involved significantly larger than in deterministic parsers, which use a simple stack.
Moreover, in order to handle the full class of context-free grammars,
the graph-like data structures in \emph{all} these algorithms need to be \emph{mutable} and allow \emph{cycles}.
Even where it does not significantly complicate the implementation,
it makes reasoning about the algorithm more difficult.

We present a new generalized context-free parsing algorithm which we call \bld{relational parsing}.
Similarly to existing approaches, it simulates possible runs of a pushdown automaton (specifically, a recursive transition network).
However, its formulation is based on precise mathematical semantics, given in Section~\ref{sec:algorithm}:
it inductively computes the languages of configurations reachable after reading consecutive input symbols.
We show that each such language can be obtained from the previous one by a constant number of simple, well-known language-theoretic operations.
The way of representing these languages (and their grammar-dependent atomic building blocks) is left abstract at this point.

We give possible concrete realizations of the above abstract data types in Section~\ref{sec:representations}.
We prove that the atomic building blocks are regular languages,
and represent them by nondeterministic finite automata, precomputed from the grammar.
For the languages computed during parsing, we use a DAG structure akin to the graph-structured stack.
However, with our approach, all cyclicity is embedded in the atomic automata,
and we \emph{never} need to add edges to existing DAG nodes.
The input-related complexity of the combined algorithm, discussed in Section~\ref{sec:complexity}, matches the state of the art:
our parser is worst-case cubic, quadratic on unambiguous grammars, and linear on LR-regular grammars.

There are multiple benefits of our clean, semantic approach.
The automata representing atomic languages can be optimized.
More importantly, due to immutability, partial results can be memoized and reused.
In Section~\ref{sec:memoization} we outline how to achieve such reuse using a more complex representation of languages.
On practical inputs (Java~8 grammar and a large set of inputs)
it allows a \emph{vast majority} of phases to be performed on a plain stack,
which makes our (unoptimized) proof-of-concept C$^\sharp$ implementation significantly outperform (our, unoptimized implementation of) GLL.
In recognition mode the speed-up is close to \emph{two orders of magnitude}---%
the running times are on par with those of the hand-coded deterministic parser used by the Java compiler.

Finally, in Section~\ref{sec:related} we discuss how our approach fits into the generalized parsing landscape.
We show how the bits and pieces of our algorithm relate to the seminal work of Lang, Earley, and Tomita,
as well as to GLL, GLR, GLC (generalized left-corner), reduction-incorporated parsers, and Adaptive LL(*) employed by ANTLR4.
%Because we have not yet developed an optimized implementation, no speed comparisons with existing implementations are given.
Within the discussion we also hint at some places where our algorithm could be improved, or our approach extended.

Due to space restrictions, this conference paper only presents the algorithm for context-free \emph{recognition}.
However, our approach generalizes cleanly to a full parser---%
instead of languages of reachable configurations, we compute the relations between configurations and the ways in which they can be reached
(hence the algorithm name).
The algorithm can actually work over an arbitrary semiring:
this includes recognition, parsing, counting parse trees, and other useful types of queries (cf.~\cite{semiring}).
A manuscript with the details of the fully general approach (and containing also the proofs omitted here) is available at \url{https://www.arxiv.org/abs/1902.06591}.
Our proof-of-concept implementation can be accessed at \url{https://gitlab.com/alt-lang/research/relational-parsing}.



\section{The algorithm}
\label{sec:algorithm}

There are many equivalent formalisms capturing context-free languages.
In this work, we use \emph{recursive transition networks}~\cite{rtn},
a restricted class of nondeterministic pushdown automata.
They directly model the computational behavior of (nondeterministic) recursive descent parsers,
and at the same time can be \emph{trivially} obtained from context-free grammars.%
\footnote{This includes popular variants of context-free grammars in which regular expressions can be used at right-hand sides of production rules.}
Importantly, the states obtained in such translation are exactly the "items" used by Earley's, GLL, (G)LC, (G)LR, and multiple other parsers.
Let us begin with a quick review of the chosen model.

\begin{definition}
  A \bld{recursive transition network (RTN)} over a terminal alphabet $A$ and set of production labels%
  \footnote{The labels are never looked at by our algorithm.
  However, they can be attached to internal parse tree nodes---%
  a role usually served by grammar productions, hence the name.}
  $P$ consists of:
  \begin{itemize}
    \item a finite set $S$ of states, with a distinguished start state $\sstart \in S$,
    \item a finite set $D$ of transitions, each being one of:
      \begin{itemize}
        \item $\shift{s,a,t}$ with $s,t \in S$ and $a \in A$,
        \item $\call{s,u,t}$ with $s,u,t \in S$, or
        \item $\reduce{s,p}$ with $s \in S$ and $p \in P$.
      \end{itemize}
  \end{itemize}
\end{definition}

Throughout the paper, we assume to be working with a single network,
and thus consider $A$, $S$, $D$ and $P$ to be fixed.
For convenience, we let $D_a$ denote the set of shifts for each particular symbol $a \in A$,
and $D_\epsilon$---the set of all non-shift transitions.

Recognition by an RTN begins in the state $\sstart$.
At each moment, the network may nondeterministically choose any legal transition from its current state $s$.
A $\shift{s,a,t}$ consumes the symbol $a$ from the input and changes the state to $t$,
$\call{s,u,t}$ recursively invokes recognition from state $u$ and moves to $t$ once the recursive call returns,
and $\reduce{s,p}$ returns from a single level of recursion.
An input $\alpha$ belongs to the language of the RTN
if there is a sequence of legal transitions which consumes the whole $\alpha$,
and ends by returning from the top recursion level.
If a parse tree is to be constructed,
its shape follows exactly the nesting of recursive calls made,
with $p$ from $\reduce{s,p}$ used to label the resulting node.

Making the recursion stack explicit, the recognition process can be formalized as follows:

\begin{definition}
  A \bld{configuration} of a recursive transition network is a stack of its states, i.e. a member of $S^*$
  (the top---current---state is the first in such sequence).
  Each transition $d \in D$ induces the following \bld{reachability} relation $\move[d]$ between configurations:
  \[
    s \con \sigma \move[\shift{s,a,t}] t \con \sigma, \qquad
    s \con \sigma \move[\call{s,u,t}] u \con t \con \sigma, \qquad
    s \con \sigma \move[\reduce{s,p}] \sigma.
  \]
  Reachability generalizes to sequences of transitions (by composing relations for consecutive transitions),
  and then to languages of transitions (by taking the union of relations for individual transition sequences).
  A sequence of transitions is \bld{viable} if it induces a nonempty reachability relation.
\end{definition}

Our recognition algorithm will simulate the nondeterministic choices made by the RTN
by computing the sets of configurations reachable after consuming consecutive symbols from the input.
To avoid dealing with empty configurations, we augment the set of states $S$ by a fresh state $\sstop$ (with no outgoing transitions)
and use it as a guard marking the bottom of each configuration.

\begin{definition}
  For an input $\alpha \in A^*$,
  the \bld{parsing language} $\Sigma_{\alpha} \subseteq S^*$
  consists of configurations (augmented with $\sstop$) reachable from the initial configuration when parsing $\alpha$:
  \[
    \Sigma_{a_1 \cons a_n} \deq \{\sigma \con \sstop:\ \sstart \move[\Eps \con D_{ a_1} \cons \Eps \con D_{a_n} \con \Eps] \sigma \}.
  \]
\end{definition}

The question of whether an input belongs to the language recognized by the network
is now the same as whether its parsing language contains the configuration $\sstop$.
The following definition allows constructing this language inductively, symbol by symbol:

\begin{definition}
  The \bld{call-reduce closure} and \bld{shift by a symbol $a \in A$} of a language $\Sigma \subseteq S^*$
  are the sets of configurations reachable from $\Sigma$ without shifts and by shifting $a$, respectively:
  \begin{align*}
    \C\Sigma &\deq \{\sigma':\ \sigma \move[\Eps]\sigma',\ \sigma\in\Sigma \}, \\
    \S[a]\Sigma &\deq \{\sigma':\ \sigma \move[D_a] \sigma',\ \sigma\in\Sigma \}.
  \end{align*}
\end{definition}

Based on the obvious observation that $\Sigma_{\epsilon} = \C\sstart \con \sstop = \C\sstart \con \C\sstop$ and $\Sigma_{\alpha a} = \C{\S[a]{\Sigma_{\alpha}}}$,
we propose Algorithm~\ref{alg:main-recognize} as a generic blueprint for context-free recognition.
Assume for the moment that we already have the closures of individual states.
The main line of development of this paper is showing how line~3, called a \bld{phase}, can be performed efficiently.

\begin{algorithm}\label{alg:main-recognize}
  Checking whether $\alpha \in A^*$ belongs to the language of the RTN
  \begin{lstlisting}
  $\Sigma \assign \C\sstart \con \C\sstop$
  foreach $a \in \alpha$ (in order):
    $\Sigma \assign \expandafter\C{\S[a]\Sigma}$
  return whether $\sstop \in \Sigma$
  \end{lstlisting}
\end{algorithm}

\begin{algorithm}\label{alg:phase-recognize-naive}
  Calculating $\C{\S[a]\Sigma}$
  \begin{lstlisting}
  $\Sigma\out \assign \varnothing$
  foreach $s_0 s_1 \cons s_k \in \Sigma$:
    foreach $\shift{s_0,a,t} \in D_a$:
      $\Sigma\out \assign \Sigma\out \ \cup\  \C{t} \con s_1 \cons s_k$
      if $t \move[\Eps]\epsilon$:
        $\Sigma\out \assign \Sigma\out \ \cup\  \C{s_1} \con s_2 \cons s_k$
        if $s_1 \move[\Eps]\epsilon$:
          $\Sigma\out \assign \Sigma\out \ \cup\  \C{s_2} \con s_3 \cons s_k$
          ...
  return $\Sigma\out$
  \end{lstlisting}
\end{algorithm}

Let us begin with a na\"ive implementation, presented as Algorithm~\ref{alg:phase-recognize-naive}.
While obviously correct, it is not directly usable,
as the loop in line~2 ranges over potentially infinite $\Sigma$.
To deal with this issue, we rephrase it in terms of language derivatives.

\begin{definition}
  A \bld{derivative of degree $k$} of a language $\Sigma \subseteq S^*$ by a symbol $s \in S$
  is any collection of languages $\Sigma\deriv{s} = \{\Sigma_i\}_{i = 1 \ldots k}$
  such that for each $\sigma \in S^*$ we have
  \[
    s \con \sigma \in \Sigma  \iff  \sigma \in \bigcup_i \Sigma_i.
  \]
  A language is \bld{$(m,k)$-regular} if it belongs to some family of size $m$, closed under derivatives of degree $k$.
  It is \bld{$k$-regular} if it is $(m,k)$-regular for some (finite) $m$, and \bld{regular} if it is $k$-regular for some $k$.
\end{definition}

This definition of regular languages is equivalent to the standard one.
The parameter $m$ measures the size of an automaton recognizing such language,
while $k$---the degree of its nondeterminism.
In particular, derivatives of degree one are exactly those of Brzozowski~\cite{Brzozowski}.

Derivatives let us look at the first (top) state in a configuration,
keeping everything that lies below it encapsulated.
This leads to Algorithm~\ref{alg:phase-recognize-deriv} which, while still operating on potentially infinite objects,
no longer needs to explicitly examine their contents.
As we will show in Section~\ref{sec:representations}, all languages encountered during recognition are regular,
and thus have a finite representation on which the necessary operations can be performed efficiently.

\begin{algorithm}\label{alg:phase-recognize-deriv}
  Calculating $\C{\S[a]\Sigma}$ using derivatives
  \begin{lstlisting}
  $\Sigma\out \assign \varnothing$
  foreach $\shift{s,a,t} \in D_a$:
    foreach $\Sigma_0 \in \Sigma\deriv{s}$:
      $\Sigma\out \assign \Sigma\out \ \cup\  \C{t} \con \Sigma_0$
      if $t \move[\Eps]\epsilon$, foreach $s_1 \in S$:
        foreach $\Sigma_1 \in \Sigma_0\deriv{s_1}$:
          $\Sigma\out \assign \Sigma\out \ \cup\  \C{s_1} \con \Sigma_1$
          if $s_1 \move[\Eps]\epsilon$, foreach $s_2 \in S$:
            foreach $\Sigma_2 \in \Sigma_1\deriv{s_2}$:
              $\Sigma\out \assign \Sigma\out \ \cup\  \C{s_2} \con \Sigma_2$
              ...
  return $\Sigma\out$
  \end{lstlisting}
\end{algorithm}

Nested iteration in Algorithm~\ref{alg:phase-recognize-deriv} could be implemented using bounded recursion.
However, the only reason for the nesting is taking derivatives by successive nullable states
(a state $s$ is \bld{nullable} if $s \move[\Eps] \epsilon$).
Let us therefore introduce a condition on languages, requiring all nullable states to be (optionally) skipped:

\begin{definition}%
  A language $\Sigma \subseteq S^*$ is \bld{null-closed}\,%
  \footnote{The definitions of call-reduce closure and null closure given here are sufficient for a correct, cubic-time recognition and parsing algorithm.
  However, to allow parsing over non-idempotent semirings, and prove sub-cubic time bounds for restricted grammar classes,
  one needs to be careful not to introduce artificial ambiguity into the configuration languages computed.
  In the full version of the paper we show how this can be achieved by a simple yet subtle adjustment of these two definitions.}
  if for each $S \ni s \move[\Eps] \epsilon$ and $\sigma_1,\sigma_2 \in S^*$ we have
  \[
    \sigma_1 \con s \con \sigma_2 \in \Sigma \implies \sigma_1\con\sigma_2 \in \Sigma.
  \]
  The \bld{null closure} of a language $\Sigma$ is the smallest null-closed language $\N\Sigma \supseteq \Sigma$.
\end{definition}

Now, for null-closed $\Sigma$, the phase algorithm can be rewritten as Algorithm~\ref{alg:phase-recognize-deep}.
Lines~5--7 are necessary because the state $s'$ could have entered the language "in the middle" of a call-reduce closure,
and thus might itself not have been call-reduce closed.

\begin{algorithm}\label{alg:phase-recognize-deep}
  Calculating $\N{\C{\S[a]\Sigma}}$ for null-closed $\Sigma$
  \begin{lstlisting}
  $\Sigma\out \assign \varnothing$
  foreach $\shift{s,a,t} \in D_a$:
    foreach $\Sigma_0 \in \Sigma\deriv{s}$:
      $\Sigma\out \assign \Sigma\out \ \cup\  \N{\C{t}} \con \Sigma_0$
      if $t \move[\Eps]\epsilon$, foreach $s' \in S$:
        foreach $\Sigma_1 \in \Sigma_0\deriv{s'}$:
          $\Sigma\out \assign \Sigma\out \ \cup\  \N{\C{s'}} \con \Sigma_1$
  return $\Sigma\out$
  \end{lstlisting}
\end{algorithm}

We would now like to take Algorithm~\ref{alg:main-recognize} and replace all call-reduce closures by their null closures.
The correctness of such change needs to be justified---we do so by the following reasoning.

\begin{lemma}
  \label{lem:shift-recognize}
  $\S[a]{\N\Sigma} \subseteq \N{\S[a]\Sigma}$ for every call-reduce-closed language $\Sigma \subseteq S^*$.
\end{lemma}

\begin{lemma}
  \label{lem:closure-recognize}
  $\C{\N\Sigma} \subseteq \N{\C\Sigma}$ for every language $\Sigma \subseteq S^*$.
\end{lemma}

\begin{proposition}
  \label{prop:main-recognize}
  $\N{\Sigma_{\epsilon}} = \N{\C{\sstart\con\sstop}}$ and $\N{\Sigma_{\alpha a}} = \N{\C{\S[a]{\N{\Sigma_{\alpha}}}}}$.
\end{proposition}
\begin{proof}
  The first equality follows directly from the definition of $\Sigma_{\epsilon}$.
  The second one can be obtained by combining Lemmas~\ref{lem:shift-recognize} and~\ref{lem:closure-recognize},
  idempotency of null closure, and monotonicity of null closure, shift and call-reduce closure into the following:
  \[
    \N{\C{\S[a]{\N{\Sigma_{\alpha}}}}} \subseteq
    \N{\C{\N{\S[a]{\Sigma_{\alpha}}}}} \subseteq
    \N{\N{\C{\S[a]{\Sigma_{\alpha}}}}} =
    \N{\N{\Sigma_{\alpha a}}} =
    \N{\Sigma_{\alpha a}} =
    \N{\C{\S[a]{\Sigma_{\alpha}}}} \subseteq
    \N{\C{\S[a]{\N{\Sigma_{\alpha}}}}}.
  \]
\end{proof}

As a consequence, plugging Algorithm~\ref{alg:phase-recognize-deep} into Algorithm~\ref{alg:main-recognize} (with all call-reduce closures replaced by their null closures)
we obtain a procedure for context-free recognition,
realizable using any data type $\type\Sigma$ representing languages over $S$, implementing API~\ref{api:languages}.

\begin{api}\label{api:languages}
  Operations required for recognition.
  \begin{itemize}
    \item $\texttt{root}() \in \type\Sigma$ \tab returns \tab $\{\epsilon\}$,
    \item $\texttt{prepend}(\N{\C{s}}; \Sigma \in \type\Sigma) \in \type\Sigma$ \tab\tab $\N{\C{s}} \con \Sigma$,
    \item $\texttt{union}(\Sigma_1,\Sigma_2 \in \type\Sigma) \in \type\Sigma$ \tab\tab $\Sigma_1 \cup \Sigma_2$,
    \item $\texttt{epsilon}(\Sigma \in \type\Sigma) \in \{\texttt{true},\texttt{false}\}$ \tab\tab whether $\epsilon \in \Sigma$,
    \item $\texttt{derivative}(\Sigma \in \type\Sigma; s \in S) \in \type\Sigma^{\leqslant k}$ \tab\tab $\Sigma\deriv{s}$.
  \end{itemize}
\end{api}



\section{Representations}
\label{sec:representations}

We will now formulate the key observation underlying this paper:
although the sets of reachable parser configurations are sometimes infinite,
their regularity makes it possible to manipulate them efficiently.


\paragraph*{Parsing languages}
\label{sec:dag}

We begin top-down, by presenting a data structure implementing API~\ref{api:languages}.
To make it independent of the grammar, let us parameterize it with a data type $\type\Upsilon$,
representing a finite family of languages over $S$, closed under taking derivatives.
We allow the first argument of \texttt{prepend} to be any element of $\type\Upsilon$.

Denote by $\efree\Sigma$ the $\epsilon$-free part of $\Sigma$ (i.e., $\Sigma - \{\epsilon\}$).
Our implementation is based on the following observation:

\begin{proposition}
  \label{prop:language-shape}
  Let $\Sigma_1, \Sigma_2, \ldots, \Sigma_n$ be a sequence of languages over $S$,
  in which each $\Sigma_i$ is obtained by applying one of the operations of API~\ref{api:languages} to some $\Sigma_j$ with $j < i$.
  Then there exists a finite collection of pairs $\{ (\Upsilon_j, i_j) \}_{j}$ with $\Upsilon_j \in \type\Upsilon$ and $1 \leqslant i_j < n$, such that
  \[
    \efree{\Sigma_n} = \bigcup_j \efree{\Upsilon_j} \con \Sigma_{i_j}.
  \]
\end{proposition}
\begin{proof}
  We argue by induction on $n$.
  For languages obtained by calling \texttt{derivative}, the inductive step follows by
  \[
    \efree{\Sigma_n\deriv{s}} \ =\
    \efree{\efree{\Sigma_n}\deriv{s}} \ =\
    \efree{\bigcup_j \bigcup_{\Upsilon' \in \efree{\Upsilon_j}\deriv{s}} \Upsilon' \con \Sigma_{i_j}} \ =\
    \bigcup_{\substack{j \\ \Upsilon' \in \Upsilon_j\deriv{s}}} \efree{\Upsilon'} \con \Sigma_{i_j}
      \ \cup\  \bigcup_{\substack{j \\ \epsilon \in \Upsilon' \in \Upsilon_j\deriv{s}}} \efree{\Sigma_{i_j}},
  \]
  and applying the inductive hypothesis to the latter part of the sum. All other cases are trivial.
\end{proof}

Our proposed data structure keeps, for each $\Sigma_n$, the set of pairs warranted above,
and an additional bit denoting whether $\epsilon \in \Sigma_n$.
All operations have natural implementations, with \texttt{derivative} following the above proof.
Their complexity will be analyzed in Section~\ref{sec:complexity}.
Here, we note only that, as language union is idempotent, any duplicate pairs encountered can and should be merged.
Thus, each $\Sigma_n$ is represented by at most $n\,|\type\Upsilon|$ pairs.

The whole structure can be viewed as a DAG, whose vertices correspond to the languages $\Sigma_i$.
Edges, labeled with elements of $\type\Upsilon$, follow the references from Proposition~\ref{prop:language-shape}:
an edge $(u, v)$ with label $\Upsilon$ is present iff the decomposition of $\efree{\Sigma_u}$ contains the pair $(\Upsilon, v)$.
Each vertex is additionally labeled with the $\epsilon$ bit---vertices at which this bit is set will be called \bld{final}.


\paragraph*{Atomic closures}

We now turn to the call-reduce closures of individual states.
The constructive proof of the proposition below presents a possible direct representation using nondeterministic finite automata.
These could of course be determinized and minimized,
but it might not be advantageous to do so---%
the price for less nondeterminism is a larger automaton size,
and the grammar-related complexity of our complete algorithm depends on both.

For an arbitrary $s \in S$ and $\sigma \in S^*$, let us denote
\[
  \P{s}{\sigma} \deq \{ \sigma' :\ s \move[\Eps] \sigma\con\sigma' \}.
\]
In particular, $\C{s} = \P{s}{\epsilon}$.
By definition, the derivatives of any $\P{s}{\sigma}$ can be expressed as
\[
  \P{s}{\sigma}\deriv{u} = \{ \P{s}{\sigma \con u} \}.
\]
This, however, does not directly lead to a \emph{finite} family closed under derivatives.
Instead, we show the following.

\begin{lemma}\label{lem:atomic-regular}
  For every $s, t, u \in S$, the derivatives of $\P{s}{t}$ are
  \[
    \P{s}{t}\deriv{u} = \{ \P{s}{t'} :\ t'' \move[\Eps] t \text{ for some } \call{t',t'',u} \in D \}.
  \]
\end{lemma}

\begin{corollary}
  \label{lem:closure-regular}
  For each $s \in S$, the language $\C{s}$ is $(|S|+1,|S|)$-regular.
\end{corollary}
\begin{proof}
  Indeed, by the above lemma,
  for each $s \in S$, the family containing $\C{s} = \P{s}{\epsilon}$ and $\P{s}{t}$ for every $t \in S$
  is closed under derivatives of degree $|S|$.
\end{proof}

This result can be carried over to null closures of atomic languages:
when taking derivatives, nullable states might need to be skipped over,
which in the language of finite automata corresponds to taking $\epsilon$-closure,
possibly for the price of increased nondeterminism.

\begin{proposition}
  For each $s \in S$, the language $\N{\C{s}}$ is $(|S|+1, |S|)$-regular.
\end{proposition}

As a consequence,
the required closures of grammar states, together with all their derivatives,
might be represented during parsing simply by pairs of states.



\section{Complexity}
\label{sec:complexity}

We will now show that the input-related complexity of our algorithm from Section~\ref{sec:algorithm},
run using the representations of languages given in Section~\ref{sec:representations},
matches that of Earley parser~\cite{earley} with Leo's improvement~\cite{leo}.
To our best knowledge this is the best among state-of-the-art generalized parsers.

\begin{proposition}
  \label{prop:complexity-cubic}
  With the proposed implementation, a sequence of $n$ operations from API~\ref{api:languages} takes time $O(n^3)$.
\end{proposition}
\begin{proof}
  As noted before, each language in such a sequence can be represented by at most $n\,|\type\Upsilon| = n(|S|+1) = O(n)$ pairs.
  When computing \texttt{derivative}, one possibly needs to examine (and combine) the representations of all $\Sigma_{i_j}$ "directly referenced" by the current $\Sigma_n$.
  This takes time $O(n^2)$.
  Running times of \texttt{union} and \texttt{prepend} are linear in the size of its arguments, and testing for $\epsilon$ is $O(1)$.
  Summing over the sequence of $n$ operations gives the desired $O(n^3)$.
\end{proof}

\begin{corollary}
  Recognizing an input of length $n$ takes time $O(n^3)$.
\end{corollary}

To be able to give better complexity bounds for restricted classes of grammars,
we will make the standard natural assumption that each state in the grammar is \bld{productive},
i.e., yields some (possibly empty) terminal word.
Detecting and removing non-productive states can be easily done during parser generation.

The consequence of this assumption is that every reachable \emph{configuration} is also productive.
This allows us to prove the following:

\begin{proposition}
  \label{prop:complexity-quadratic}
  When the recursive transition network is unambiguous,
  recognizing an input of length $n$ takes time $O(n^2)$.
\end{proposition}
\begin{proof}
  Each way a configuration can "enter" into a parsing language corresponds to some viable sequence of RTN transitions.
  In particular, should any configuration have more than one such way, the grammar would be ambiguous.
  This implies that, for unambiguous grammars, all unions---%
  those requested explicitly and those performed internally by \texttt{derivative}, are in fact disjoint.
  This makes each operation run in time proportional to the size of its result (i.e., the outdegree of the vertex created).
  Consequently, the complexity of the \emph{whole sequence} of operations is linear in the size of the complete DAG constructed.
  The result follows.
\end{proof}

It turns out that for LR-regular grammars (this class contains LR(k) for all k, and thus most deterministic grammars),
the size of the DAG is always linear in the input length:

\begin{proposition}
  \label{prop:complexity-linear}
  When parsing according to a recursive transition network which is LR-regular,
  the outdegree of each DAG node created is bounded by a constant.
\end{proposition}

\begin{corollary}
  When the recursive transition network is LR-regular,
  recognizing an input of length $n$ takes time $O(n)$.
\end{corollary}



\section{Memoization}
\label{sec:memoization}

We find the mathematical clarity of our algorithm to be a virtue on its own.
In particular, it opens a clear way of investigating potentially more effective data representations,
and making use of language-theoretic algorithms, like optimization of nondeterministic automata.
However, an aspect we find especially beneficial is the immutability of the intermediate objects computed during parsing.
This is because it allows memoizing and reusing the results of computation.
We report on this aspect in this section.

To show the possible effects of memoization on practical programming languages,
we have chosen a grammar for Java 8 from the ANTLR4 grammar repository
(\url{https://github.com/antlr/grammars-v4/blob/master/java8/Java8.g4};
this grammar is ambiguous, but extremely close to the Java language specification)
and a large, popular Java project (\texttt{elasticsearch-6.5.3}, with 9596 \texttt{.java} files totalling over 10 million terminals).


\paragraph*{Trivial memoization}

The most obvious way in which one can reuse the results of previous phases of computation is the following:
if $\N{\Sigma_\alpha} = \N{\Sigma_\beta}$ then $\N{\Sigma_{\alpha \con a}} = \N{\Sigma_{\beta \con a}}$.
To build an intuition on when configuration languages at different input positions can be equal,
imagine the structure of a standard, "hierarchical" programming language,
in which syntactic structures (like classes, functions, code blocks, parenthesized expressions, etc.) nest within one another.
A grammar of such a language will most likely contain productions corresponding to particular structures.
In turn, a parser configuration at an input position where some structures are "currently open"
will contain a sequence of states from those productions.
Of course, even for deterministic grammars, there can be more than one reachable configuration at a given point.
However, the general intuition holds: input locations with identical "nesting structure" will often share configuration languages.
This happens both within a single input, and across multiple inputs.
On our test case, over 94\% of phase computations have been taken from cache.
Computing the remaining 6\% took 96\% of total recognition time---%
this shows how expensive the DAG operations are compared to a simple dictionary lookup.


\paragraph*{Dominator-based memoization}

To further develop our inuition on configuration languages,
imagine a syntactic language structure requiring a specific closing terminal (e.g., \texttt{\}}).
Looking at the parsing stack, the state (say, $s$) corresponding to such structure being "currently open" cannot be reduced until the closing terminal is encountered.
During this period, every configuration will have the form $\sigma \con s \con \tau$, with varying $\sigma$ but identical $\tau$.
Our parser will not even look at $\tau$ until it is uncovered by taking a derivative by $s$.
This means that computation results for one $\tau$ can be "transplanted" on top of another,
as long as they have at least one state "covering" this bottom part of the stack.

To make use of this observation we need to significantly complicate our representation of languages.
A language will now be represented as a \emph{stack} of DAG vertices,
its semantics being the concatenation (top-to-bottom) of languages corresponding to individual vertices.
To keep the languages deeper in the stack "covered", we require all but the bottom vertices \emph{not} to be final (i.e., to denote $\epsilon$-free languages).
Should we ever attempt to push a final vertex on a nonempty stack, we instead merge it with the current top,
computing the concatenation of their corresponding languages.

During each phase, we keep track of how long a prefix of the stack we have seen.
Note, that uncovering $k$ deeper vertices requires taking derivatives by at least $k$ states, and a single phase takes derivatives by at most two of them.
Together with the potential merge to keep the $\epsilon$-free invariant, this means that a phase will examine at most three top stack entries.
When a phase is done, its result (a single DAG vertex $v$, about to be placed on top of the part of the stack which has not been touched) is first \bld{factorized}:
the fragment of the DAG between $v$ and all final vertices reachable from it is split at all their common dominators.
The resulting factors are represented by individual vertices, and these are pushed on the stack instead of $v$.

Such partial phase computations are held in a trie,
which maps a terminal and a prefix (with at most three elements) of the stack into a prefix it should get replaced with.
Whenever the top of the stack is found in the trie, phase computation requires only a handful of simple stack operations.
It our test case, this happens in over 99.7\% of phases.
Due to increased complexity of the data structures, the remaining 0.3\% phases now take about 40\% of total recognition time.


\paragraph*{Recognition speed}

\begin{figure}
  \centering
  \begin{tabular}{l|r|r}
    algorithm & time [s] & memory [GB] \\
    \hline\hline
    GLL & 2445.6 & 0.32 \\
    GLL (non-optimized grammar) & 470.2 & 0.15 \\
    \hline
    relational (no memoization) & 751.4 & 2.42 \\
    relational (trivial memoization) & 77.5 & 3.22 \\
    relational (dominator-based memoization) & 7.8 & 0.22 \\
    relational (dominator-based, non-optimized) & 30.3 & 1.08 \\
    \hline
    \texttt{javac} (parser) & 14.0 & 0.93 \\
    \hline
  \end{tabular}
  \caption{Running times\footnotemark{} and memory usage\footnotemark{} of compared recognition algorithms.}
  \label{fig:timings}
\end{figure}

\addtocounter{footnote}{-2}
\stepcounter{footnote}\footnotetext{While other timings are for parsing alone, the one for \texttt{javac} includes tokenizing the input and building parse trees.
However, in a hand-coded, deterministic parser, we would not expect these two tasks to take significantly more than half of total execution time.
Also, these results are for recognition: generating parse forests using our method \emph{is} fast, but not \emph{that} fast---%
for details, please consult the full version.}
\stepcounter{footnote}\footnotetext{Memory usage has been measured for the whole process, including .NET Core or Java VM.}

Even though our proof-of-concept implementation has not been created with speed in mind,%
\footnote{It has multiple additional layers of abstraction, useful for experimenting with different representations.
In C$\sharp$, the overhead of these layers cannot be eliminated at compile-time and must be paid during parsing.
It seems a well-structured C++ implementation could do significantly better.}
we have decided to provide here a short "raw speed" comparison between our algorithm, GLL, and the hand-coded parser being part of the current Java 8 compiler \texttt{javac}.
The timings have been taken on a modest laptop, with 3 GHz Intel Core i7 CPU and 8 GB of RAM, running 64-bit Linux.
All parsers have been restricted to use a single CPU core.
The results are gathered on Figure~\ref{fig:timings}.

The grammar given to both GLL and our parser has been left-factored
and then optionally optimized by simple partition refinement analogous to Moore's method of minimizing finite automata.
These steps reduced the number of RTN states from 3132 to 2818 and 638, respectively.
While optimization has helped our method, reducing the cardinality of $\type\Upsilon$ from 5503 to 2949,
it has made GLL perform significantly worse by making its GSS denser.



\section{Related work}
\label{sec:related}

Parsing is a vast subject (see, e.g.~\cite{grune}),
thus here we only touch on what we find to be most relevant to our algorithm.
We also hint at some potential future improvements.

\paragraph*{Simulating nondeterministic pushdown automata}

Effective simultaneous simulation of possible runs of a PDA has been proposed by Lang~\cite{pda-simulation}.
In~\cite{tomita,gss}, Tomita presented the graph-structured stack as a convenient structure for capturing such nondeterminism.
This has led to a multitude of generalized parsers, differing primarily by the automaton being simulated:
this includes the GLR family (e.g.,~\cite{brnglr}), GLC~\cite{glc,glc-improved}, and GLL~\cite{gll,gll-performance}.

As Lang's, our method could be adjusted to simulate other versions of pushdown automata.
It is even conceivable that an appropriate "phase function" could be obtained automatically for an arbitrary PDA,
and still require only a constant number of primitive language operations.
We have not investigated this path.

The Adaptive LL(*) algorithm~\cite{allstar}, underlying the popular ANTLR4 parser generator, uses simulation to predict valid transitions.
It represents configuration sets explicitly, and thus fails to handle left-recursive grammars, where these sets can be infinite.
Our approach, originally aimed to remove this restriction, abstracts away the specific representation.
In fact, we have first used a "standard" GSS instead of the proposed DAG structure---%
however, in such case we failed to attain linear complexity on some LR-regular grammars.

\paragraph*{Left- and right-recursive productions}

For top-down (predictive) parsers, left-recursive productions are inherently problematic,
because it is difficult to know up front how many times a \texttt{call} loop should be followed.
Thus, most algorithms in the LL family refuse to handle such grammars.
GLL captures \emph{all} possible runs through left recursion by introducing cycles into its graph-structured stack,
and so does Earley's algorithm (cyclicity here takes the form of an item referencing its own layer).

Right recursion requires special attention when reduction possibilities are considered,
because it may happen that a new way of reaching some state in discovered \emph{after} it has been "processed".
All nondeterminism-simulating parsers handle this using work queues or other mutable data structures.
Similar care (and mutability) is needed in Earley-style parsers.

With simultaneous left and right recursion,
the grammar is infinitely ambiguous,
and thus the final result of parsing \emph{must} be cyclic.
Relational parsing integrates both left and right recursion into the atomic languages,
thus completely avoiding the need for cyclic structures and mutation during parsing.
To our best knowledge it is the first algorithm with this property.

Right recursion influences also the complexity of generalized parsers,
as it can make linearly long sequences of reductions available at each input position.
Some parsers, including Earley's, use lookahead to avoid incurring quadratic complexity on LR(k) grammars.
Another approach, used in Leo's modification~\cite{leo} and applicable to all LR-regular grammars \emph{without} using lookahead,
is to create shortcuts through such long reduction paths.
This is precisely what we achieve by the decomposition proposed in Proposition~\ref{prop:language-shape}.

\paragraph*{Nullables}

Nullable states (nonterminals) seem to be a nuisance for every parsing algorithm.
Although theoretically one could avoid dealing with them by rewriting the grammar,
it is impractical to do so: binary grammars can grow quadratically, and arbitrary ones---exponentially.
Right-nulled GLR~\cite{rnglr,rnglr-optimize} avoids the exponential blow-up by only eliminating trailing nullables in each production.
Most other algorithms attempt to handle all nullables "on the fly".
In our case, this amounts to making the atomic languages null-closed.
While it does not cause the automata to have more states, additional edges \emph{are} introduced and traversed.

In an analogous situation, the version of CYK presented in~\cite{cyk-2nf} does \emph{not} precompute the extra edges.
Instead it avoids higher grammar-related complexity by grouping together multiple walks on its "automata".
It is interesting whether this idea could somehow be adapted to our setting.

\paragraph*{Atomic closures vs.~left corners}

The slightly less popular GLC parser builds a bridge between top-down and bottom-up parsing by using the \bld{left corner relation},
containing a pair of nonterminals whenever one of them can appear leftmost in some derivation from the other.
Our proposed implementation of atomic closures is indexed by pairs of states related in exactly the same way,
and the appropriate rules of GLC mirror the transitions in our atomic automata.

The authors of GLC propose to make the algorithm more effective by grouping some of the cases heuristically.
With our approach, it is clear that one could use any automaton recognizing the same language.
This opens the way for well-understood optimizations.

\paragraph*{Memoization}

Memoization has been put to great use in the Adaptive LL(*) parsing algorithm,
even though it is only used there when predicting the right nondeterministic choice.
To make memoized computations applicable in more situations, the algorithm pretends to forget all but the top state of the RTN.
If such "blind" computation succeeds, it can then be applied on top of any stack.
However, should it fail, the algorithm resorts to non-memoized computation with full stack information.
Our dominator-based memoization handles such situations better, and in a way optimally:
we always look at exactly such stack depth as is necessary.

\paragraph*{Limiting stack activity}

It is well known that the primary source of inefficiency in generalized parsers is handling large graph-like structures (i.e., the GSS), offering poor cache locality.
Reduction-incorporated parsers (cf.~\cite{riglr}) attempt to limit the size of these graphs by handling most of the grammar using finite automata, and using the stack only when necessary.
Appropriate pushdown automata can be constructed in multiple ways,
and thus in~\cite{riglr-optimize} the authors suggest selecting the best one by profiling the parser on sample inputs.

In our algorithm, \emph{all} activity between successive terminals is handled by the automata for atomic languages.
Furthermore, instead of limiting the depth of the (multiple) stacks, we perform most---even locally ambiguous---operations on a \emph{single} stack.
With dominator-based memoization, the algorithm "learns" the right stack actions \emph{while} parsing,
though one could also possibly "train" it beforehand on some sample inputs.

\paragraph*{Semantics}

As far as we know, no previous generalized parsing algorithm \emph{explicitly} computes the languages of reachable configurations.
However, these languages are implicitly present in \emph{all} of them,
and often could be easily read off their data structures after processing each terminal:
in GLL for example, reachable configurations are precisely all the paths through the GSS.

We believe that our semantics-based approach opens the way not only to cleaner and more performant parsers for all context-free languages,
but possibly also to handling larger useful grammar classes,
beginning with conjunctive grammars~\cite{conjunctive} or even grammars with one- or two-sided contexts~\cite{glr-with-contexts,bicontexts,recognize-bicontexts}.





\bibliographystyle{plainurl}% the mandatory bibstyle
\bibliography{parsing}

%\appendix

\end{document}
